require("guardian")

// returning true means they can pass through it

function ShouldEntitiesCollide(ent1,ent2)
	if ent1 == ent2 then return false end
	if ent1 <= 0 || ent2 <= 0 then return false end
	local enta, entb = ents.GetByIndex(ent1), ents.GetByIndex(ent2)
	local ply, target
	if enta:IsPlayer() then ply = enta target = entb elseif entb:IsPlayer() then ply = entb target = enta end
	if target == nil or ply == nil then return false end
	//print(ply, target)

	if ply.Ghost && target:GetClass() == "prop_physics" then
		return true
	end

	return false
end

// the reason we tell the client to set them SOLID_NONE is because this only hooks server collisions, it will look a
// little odd on the client if we don't tell them they can pass through it 

function lolupdate()
	for k,v in pairs(player.GetAll()) do
		if v.Ghost then 
			v:SendLua("for k,v in pairs(ents.FindByClass('prop_physics')) do v:SetSolid(SOLID_NONE) end")
		else
			v:SendLua("for k,v in pairs(ents.FindByClass('prop_physics')) do v:SetSolid(6) end")
		end
	end
	timer.Simple(2, lolupdate)
end
timer.Simple(2, lolupdate)

concommand.Add("toggle_ghost", function(ply, args, blah)
	ply.Ghost = !ply.Ghost
end)